Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1782)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1783)
@@ -20,5 +20,6 @@
 ! Current revisions:
 ! ------------------
-!
+! calculation of nest top area simplified,
+! interpolation and anterpolation moved to seperate wrapper subroutines
 !
 ! Former revisions:
@@ -678,5 +679,4 @@
     INTEGER(iwp), DIMENSION(5) ::  val        !:
     
-    REAL(wp)                   ::  area_t_l   !:
     REAL(wp), DIMENSION(1)     ::  fval       !:
     REAL(wp)                   ::  xcs        !:
@@ -684,6 +684,4 @@
     REAL(wp)                   ::  ycs        !:
     REAL(wp)                   ::  yce        !:
-    REAL(wp)                   ::  zct        !:
-    REAL(wp), DIMENSION(4)     ::  ztt        !:
                                              
 
@@ -830,11 +828,5 @@
 !--    Finally, compute the total area of the top-boundary face of the domain.
 !--    This is needed in the pmc_ensure_nest_mass_conservation      
-       area_t_l = ( nxr + 1 - nxl ) * ( nyn + 1 - nys ) * dx * dy
-       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( area_t_l, area_t, 1, MPI_REAL, MPI_SUM, comm2d, ierr )
-
-!
-!--    TO_DO: Why not just simply? test this!
-       !area_t_l = ( nx + 1 ) * (ny + 1 ) * dx * dy            
+       area_t = ( nx + 1 ) * (ny + 1 ) * dx * dy
 
     ENDIF
@@ -1079,5 +1071,4 @@
 
       REAL(wp), ALLOCATABLE, DIMENSION(:) ::  lcr   !:
-      LOGICAL  ::  more             !:
 
 !
@@ -2399,139 +2390,10 @@
           CALL cpu_log( log_point_s(73), 'PMC Client Recv', 'stop' )
 
-!
-!--       The interpolation. Add IF-condition here: IF not vertical nesting
-          IF ( nest_bound_l )  THEN   !  Left border pe
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_u_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'u' )
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                       nzb_v_inner, logc_v_l, logc_ratio_v_l, nzt_topo_nestbc_l, 'l', 'v' )
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                       nzb_w_inner, logc_w_l, logc_ratio_w_l, nzt_topo_nestbc_l, 'l', 'w' )
-             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'e' )
-             CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                          nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
-             ENDIF
-             IF ( nesting_mode == 'one-way' )  THEN
-                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
-                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
-                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
-                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
-                CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
-                IF ( humidity  .OR.  passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
-                ENDIF
-             ENDIF
-          ENDIF
-          IF ( nest_bound_r )  THEN   !  Right border pe
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_u_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'u' )
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                       nzb_v_inner, logc_v_r, logc_ratio_v_r, nzt_topo_nestbc_r, 'r', 'v' )
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                       nzb_w_inner, logc_w_r, logc_ratio_w_r, nzt_topo_nestbc_r, 'r', 'w' )
-             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'e' )
-             CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                          nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
-             ENDIF
-             IF ( nesting_mode == 'one-way' )  THEN
-                CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
-                CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
-                CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
-                CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'r', 'e' )
-                CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'r', 's' )
-                IF ( humidity  .OR.  passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'r', 's' )
-                ENDIF
-             ENDIF
-          ENDIF
-          IF ( nest_bound_s )  THEN   !  South border pe
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_u_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'u' )
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                       nzb_v_inner, logc_v_s, logc_ratio_v_s, nzt_topo_nestbc_s, 's', 'v' )
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                       nzb_w_inner, logc_w_s, logc_ratio_w_s, nzt_topo_nestbc_s, 's', 'w' )
-             CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'e' )
-             CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
-                                          nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
-             ENDIF
-             IF ( nesting_mode == 'one-way' )  THEN
-                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
-                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 's', 'v' )
-                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 's', 'w' )
-                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 's', 'e' )
-                CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 's', 's' )
-                IF ( humidity  .OR.  passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 's', 's' )
-                ENDIF
-             ENDIF
-          ENDIF
-          IF ( nest_bound_n )  THEN   !  North border pe
-             CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_u_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'u' )
-             CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
-                                       nzb_v_inner, logc_v_n, logc_ratio_v_n, nzt_topo_nestbc_n, 'n', 'v' )
-             CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
-                                       nzb_w_inner, logc_w_n, logc_ratio_w_n, nzt_topo_nestbc_n, 'n', 'w' )
-             CALL pmci_interp_tril_sn( e,  ec,  ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                  &
-                                       nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'e' )
-             CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
-                                       nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_interp_tril_sn( q, qc, ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                 &
-                                          nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
-             ENDIF
-             IF ( nesting_mode == 'one-way' )  THEN             
-                CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
-                CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 'n', 'v' )
-                CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 'n', 'w' )
-                CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 'n', 'e' )
-                CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 'n', 's' )
-                IF ( humidity  .OR.  passive_scalar )  THEN
-                   CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
-                ENDIF
-             ENDIF
-          ENDIF
-
-!
-!--       All PEs are top-border PEs
-          CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo, 'u' )
-          CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo, 'v' )
-          CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw, 'w' )
-          CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 'e' )
-          CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
-          ENDIF
-          IF ( nesting_mode == 'one-way' )  THEN
-             CALL pmci_extrap_ifoutflow_t( u,  'u' )
-             CALL pmci_extrap_ifoutflow_t( v,  'v' )
-             CALL pmci_extrap_ifoutflow_t( w,  'w' )
-             CALL pmci_extrap_ifoutflow_t( e,  'e' )
-             CALL pmci_extrap_ifoutflow_t( pt, 's' )
-             IF ( humidity  .OR.  passive_scalar )  THEN
-                CALL pmci_extrap_ifoutflow_t( q, 's' )
-             ENDIF
-          ENDIF
-       ELSE    !  IF ( direction == server_to_client ) 
-          CALL pmci_anterp_tophat( u,  uc,  kceu, iflu, ifuu, jflo, jfuo, kflo, kfuo, nzb_u_inner, 'u' )
-          CALL pmci_anterp_tophat( v,  vc,  kceu, iflo, ifuo, jflv, jfuv, kflo, kfuo, nzb_v_inner, 'v' )
-          CALL pmci_anterp_tophat( w,  wc,  kcew, iflo, ifuo, jflo, jfuo, kflw, kfuw, nzb_w_inner, 'w' )
-          CALL pmci_anterp_tophat( pt, ptc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
-          IF ( humidity  .OR.  passive_scalar )  THEN
-             CALL pmci_anterp_tophat( q, qc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
-          ENDIF
+          CALL pmci_interpolation
+
+       ELSE    !  IF ( direction == server_to_client )
+
+          CALL pmci_anterpolation
+
           CALL cpu_log( log_point_s(74), 'PMC Client Send', 'start' )
           CALL pmc_c_putbuffer( WaitTime = WaitTime )
@@ -2539,6 +2401,160 @@
        ENDIF
     ENDIF
-    
+
  CONTAINS
+
+
+   SUBROUTINE pmci_interpolation
+
+!
+!--   A wrapper routine for all interpolation and extrapolation actions.
+      IMPLICIT NONE
+
+!
+!--   Add IF-condition here: IF not vertical nesting
+      IF ( nest_bound_l )  THEN   !  Left border pe
+         CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_u_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'u' )
+         CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
+                                   nzb_v_inner, logc_v_l, logc_ratio_v_l, nzt_topo_nestbc_l, 'l', 'v' )
+         CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
+                                   nzb_w_inner, logc_w_l, logc_ratio_w_l, nzt_topo_nestbc_l, 'l', 'w' )
+         CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 'e' )
+         CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
+         IF ( humidity  .OR.  passive_scalar )  THEN
+            CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
+                                      nzb_s_inner, logc_u_l, logc_ratio_u_l, nzt_topo_nestbc_l, 'l', 's' )
+         ENDIF
+         IF ( nesting_mode == 'one-way' )  THEN
+            CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'l', 'u' )
+            CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'l', 'v' )
+            CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'l', 'w' )
+            CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'l', 'e' )
+            CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'l', 's' )
+            IF ( humidity  .OR.  passive_scalar )  THEN
+               CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'l', 's' )
+            ENDIF
+         ENDIF
+      ENDIF
+      IF ( nest_bound_r )  THEN   !  Right border pe
+         CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_u_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'u' )
+         CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
+                                   nzb_v_inner, logc_v_r, logc_ratio_v_r, nzt_topo_nestbc_r, 'r', 'v' )
+         CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
+                                   nzb_w_inner, logc_w_r, logc_ratio_w_r, nzt_topo_nestbc_r, 'r', 'w' )
+         CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 'e' )
+         CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                   nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
+         IF ( humidity  .OR.  passive_scalar )  THEN
+            CALL pmci_interp_tril_lr( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
+                                      nzb_s_inner, logc_u_r, logc_ratio_u_r, nzt_topo_nestbc_r, 'r', 's' )
+         ENDIF
+         IF ( nesting_mode == 'one-way' )  THEN
+            CALL pmci_extrap_ifoutflow_lr( u, nzb_u_inner, 'r', 'u' )
+             CALL pmci_extrap_ifoutflow_lr( v, nzb_v_inner, 'r', 'v' )
+             CALL pmci_extrap_ifoutflow_lr( w, nzb_w_inner, 'r', 'w' )
+             CALL pmci_extrap_ifoutflow_lr( e, nzb_s_inner, 'r', 'e' )
+             CALL pmci_extrap_ifoutflow_lr( pt,nzb_s_inner, 'r', 's' )
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                CALL pmci_extrap_ifoutflow_lr( q, nzb_s_inner, 'r', 's' )
+             ENDIF
+          ENDIF
+       ENDIF
+       IF ( nest_bound_s )  THEN   !  South border pe
+          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
+                                    nzb_u_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'u' )
+          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
+                                    nzb_v_inner, logc_v_s, logc_ratio_v_s, nzt_topo_nestbc_s, 's', 'v' )
+          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
+                                    nzb_w_inner, logc_w_s, logc_ratio_w_s, nzt_topo_nestbc_s, 's', 'w' )
+          CALL pmci_interp_tril_sn( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                    nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 'e' )
+          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                    nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             CALL pmci_interp_tril_sn( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,         &
+                                       nzb_s_inner, logc_u_s, logc_ratio_u_s, nzt_topo_nestbc_s, 's', 's' )
+          ENDIF
+          IF ( nesting_mode == 'one-way' )  THEN
+             CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 's', 'u' )
+             CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 's', 'v' )
+             CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 's', 'w' )
+             CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 's', 'e' )
+             CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 's', 's' )
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 's', 's' )
+             ENDIF
+          ENDIF
+       ENDIF
+       IF ( nest_bound_n )  THEN   !  North border pe
+          CALL pmci_interp_tril_sn( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo,          &
+                                    nzb_u_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'u' )
+          CALL pmci_interp_tril_sn( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo,          &
+                                    nzb_v_inner, logc_v_n, logc_ratio_v_n, nzt_topo_nestbc_n, 'n', 'v' )
+          CALL pmci_interp_tril_sn( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw,          &
+                                    nzb_w_inner, logc_w_n, logc_ratio_w_n, nzt_topo_nestbc_n, 'n', 'w' )
+          CALL pmci_interp_tril_sn( e,  ec,  ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                  &
+                                    nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 'e' )
+          CALL pmci_interp_tril_sn( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo,          &
+                                    nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             CALL pmci_interp_tril_sn( q, qc, ico,jco,kco,r1xo,r2xo,r1yo,r2yo,r1zo,r2zo,                 &
+                                       nzb_s_inner, logc_u_n, logc_ratio_u_n, nzt_topo_nestbc_n, 'n', 's' )
+          ENDIF
+          IF ( nesting_mode == 'one-way' )  THEN
+             CALL pmci_extrap_ifoutflow_sn( u, nzb_u_inner, 'n', 'u' )
+             CALL pmci_extrap_ifoutflow_sn( v, nzb_v_inner, 'n', 'v' )
+             CALL pmci_extrap_ifoutflow_sn( w, nzb_w_inner, 'n', 'w' )
+             CALL pmci_extrap_ifoutflow_sn( e, nzb_s_inner, 'n', 'e' )
+             CALL pmci_extrap_ifoutflow_sn( pt,nzb_s_inner, 'n', 's' )
+             IF ( humidity  .OR.  passive_scalar )  THEN
+                CALL pmci_extrap_ifoutflow_sn( q, nzb_s_inner, 'n', 's' )
+             ENDIF
+          ENDIF
+      ENDIF
+
+!
+!--   All PEs are top-border PEs
+       CALL pmci_interp_tril_t( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo, r2yo, r1zo, r2zo, 'u' )
+       CALL pmci_interp_tril_t( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv, r2yv, r1zo, r2zo, 'v' )
+       CALL pmci_interp_tril_t( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo, r2yo, r1zw, r2zw, 'w' )
+       CALL pmci_interp_tril_t( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 'e' )
+       CALL pmci_interp_tril_t( pt, ptc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
+       IF ( humidity  .OR.  passive_scalar )  THEN
+          CALL pmci_interp_tril_t( q, qc, ico, jco, kco, r1xo, r2xo, r1yo, r2yo, r1zo, r2zo, 's' )
+       ENDIF
+       IF ( nesting_mode == 'one-way' )  THEN
+          CALL pmci_extrap_ifoutflow_t( u,  'u' )
+          CALL pmci_extrap_ifoutflow_t( v,  'v' )
+          CALL pmci_extrap_ifoutflow_t( w,  'w' )
+          CALL pmci_extrap_ifoutflow_t( e,  'e' )
+          CALL pmci_extrap_ifoutflow_t( pt, 's' )
+          IF ( humidity  .OR.  passive_scalar )  THEN
+             CALL pmci_extrap_ifoutflow_t( q, 's' )
+          ENDIF
+      ENDIF
+   END SUBROUTINE pmci_interpolation
+
+
+
+   SUBROUTINE pmci_anterpolation
+
+!
+!--   A wrapper routine for all anterpolation actions.
+      IMPLICIT NONE
+
+      CALL pmci_anterp_tophat( u,  uc,  kceu, iflu, ifuu, jflo, jfuo, kflo, kfuo, nzb_u_inner, 'u' )
+      CALL pmci_anterp_tophat( v,  vc,  kceu, iflo, ifuo, jflv, jfuv, kflo, kfuo, nzb_v_inner, 'v' )
+      CALL pmci_anterp_tophat( w,  wc,  kcew, iflo, ifuo, jflo, jfuo, kflw, kfuw, nzb_w_inner, 'w' )
+      CALL pmci_anterp_tophat( pt, ptc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
+      IF ( humidity  .OR.  passive_scalar )  THEN
+         CALL pmci_anterp_tophat( q, qc, kceu, iflo, ifuo, jflo, jfuo, kflo, kfuo, nzb_s_inner, 's' )
+      ENDIF
+
+   END SUBROUTINE pmci_anterpolation
 
 
Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1782)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1783)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! palm-netcdf-module removed in order to avoid a circular module dependency,
+! netcdf-variables moved to netcdf-module, new routine netcdf_handle_error_mod
+! added
 ! 
 ! Former revisions:
@@ -83,5 +85,4 @@
  MODULE radiation_model_mod
  
-
     USE arrays_3d,                                                             &
         ONLY:  dzw, hyp, pt, q, ql, zw
@@ -104,9 +105,6 @@
 
 #if defined ( __netcdf )
-    USE netcdf
+    USE NETCDF
 #endif
-
-    USE netcdf_control,                                                        &
-        ONLY:  dots_label, dots_num, dots_unit
 
 #if defined ( __rrtmg )
@@ -642,29 +640,4 @@
        CALL user_init_radiation
 
-
-!
-!--    Add timeseries for radiation model
-       dots_rad = dots_num + 1
-       dots_num = dots_num + 5
-
-       dots_label(dots_rad) = "rad_net"
-       dots_label(dots_rad+1) = "rad_lw_in"
-       dots_label(dots_rad+2) = "rad_lw_out"
-       dots_label(dots_rad+3) = "rad_sw_in"
-       dots_label(dots_rad+4) = "rad_sw_out"
-       dots_unit(dots_rad:dots_rad+4) = "W/m2"
-
-!
-!--    Output of albedos is only required for RRTMG
-       IF ( radiation_scheme == 'rrtmg' )  THEN
-          dots_num  = dots_num + 4
-          dots_label(dots_rad+5) = "rrtm_aldif"
-          dots_label(dots_rad+6) = "rrtm_aldir"
-          dots_label(dots_rad+7) = "rrtm_asdif"
-          dots_label(dots_rad+8) = "rrtm_asdir"
-          dots_unit(dots_num+5:dots_num+8) = ""
-
-       ENDIF
-
 !
 !--    Calculate radiative fluxes at model start
@@ -1098,6 +1071,4 @@
 !------------------------------------------------------------------------------!
     SUBROUTINE read_sounding_data
-
-       USE netcdf_control
 
        IMPLICIT NONE
@@ -1168,5 +1139,5 @@
 !--    Open file for reading
        nc_stat = NF90_OPEN( rrtm_input_file, NF90_NOWRITE, id )
-       CALL handle_netcdf_error( 'netcdf', 549 )
+       CALL netcdf_handle_error_rad( 'read_sounding_data', 549 )
 
 !
@@ -1174,5 +1145,5 @@
        nc_stat = NF90_INQ_DIMID( id, "Pressure", id_dim_zrad )
        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim_zrad, len = nz_snd )
-       CALL handle_netcdf_error( 'netcdf', 551 )
+       CALL netcdf_handle_error_rad( 'read_sounding_data', 551 )
 
 !
@@ -1186,5 +1157,5 @@
        nc_stat = NF90_GET_VAR( id, id_var, hyp_snd_tmp(:), start = (/1/),      &
                                count = (/nz_snd/) )
-       CALL handle_netcdf_error( 'netcdf', 552 )
+       CALL netcdf_handle_error_rad( 'read_sounding_data', 552 )
 
 !
@@ -1198,5 +1169,5 @@
        nc_stat = NF90_GET_VAR( id, id_var, t_snd_tmp(:), start = (/1/),        &
                                count = (/nz_snd/) )
-       CALL handle_netcdf_error( 'netcdf', 553 )
+       CALL netcdf_handle_error_rad( 'read_sounding_data', 553 )
 
 !
@@ -1371,5 +1342,4 @@
     SUBROUTINE read_trace_gas_data
 
-       USE netcdf_control
        USE rrsw_ncpar
 
@@ -1435,16 +1405,16 @@
 !--    Open file for reading
        nc_stat = NF90_OPEN( rrtm_input_file, NF90_NOWRITE, id )
-       CALL handle_netcdf_error( 'netcdf', 549 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 549 )
 !
 !--    Inquire dimension ids and dimensions
        nc_stat = NF90_INQ_DIMID( id, "Pressure", id_dim )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = np) 
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
 
        nc_stat = NF90_INQ_DIMID( id, "Absorber", id_dim )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
        nc_stat = NF90_INQUIRE_DIMENSION( id, id_dim, len = nabs ) 
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
    
 
@@ -1457,12 +1427,12 @@
 
        nc_stat = NF90_INQ_VARID( id, "Pressure", id_var )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
        nc_stat = NF90_GET_VAR( id, id_var, p_mls )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
 
        nc_stat = NF90_INQ_VARID( id, "AbsorberAmountMLS", id_var )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
        nc_stat = NF90_GET_VAR( id, id_var, trace_mls_tmp )
-       CALL handle_netcdf_error( 'netcdf', 550 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 550 )
 
 
@@ -1484,5 +1454,5 @@
 
        nc_stat = NF90_CLOSE( id )
-       CALL handle_netcdf_error( 'netcdf', 551 )
+       CALL netcdf_handle_error_rad( 'read_trace_gas_data', 551 )
 
 !
@@ -1623,4 +1593,30 @@
     END SUBROUTINE read_trace_gas_data
 
+    SUBROUTINE netcdf_handle_error_rad( routine_name, errno )
+
+       USE control_parameters,                                                 &
+           ONLY:  message_string
+
+       USE NETCDF
+
+       USE pegrid
+
+       IMPLICIT NONE
+
+       CHARACTER(LEN=6) ::  message_identifier
+       CHARACTER(LEN=*) ::  routine_name
+
+       INTEGER(iwp) ::  errno
+
+       IF ( nc_stat /= NF90_NOERR )  THEN
+
+          WRITE( message_identifier, '(''NC'',I4.4)' )  errno
+          message_string = TRIM( NF90_STRERROR( nc_stat ) )
+
+          CALL message( routine_name, message_identifier, 2, 2, 0, 6, 1 )
+
+       ENDIF
+
+    END SUBROUTINE netcdf_handle_error_rad
 #endif
 
Index: palm/trunk/SOURCE/read_var_list.f90
===================================================================
--- palm/trunk/SOURCE/read_var_list.f90	(revision 1782)
+++ palm/trunk/SOURCE/read_var_list.f90	(revision 1783)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! netcdf module name changed + related changes
 ! 
 ! Former revisions:
@@ -173,5 +173,6 @@
         ONLY:  damp_level_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
 
-    USE netcdf_control
+    USE netcdf_interface,                                                      &
+        ONLY:  netcdf_precision, output_for_t0
 
     USE particle_attributes,                                                   &
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1782)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1783)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! switch back of netcdf data format for mask output moved to the mask output
+! routine
 !
 ! Former revisions:
@@ -200,5 +201,5 @@
                intermediate_timestep_count_max, large_scale_forcing,           &
                loop_optimization, lsf_surf, lsf_vert, masks, mid, nest_domain, &
-               netcdf_data_format, neutral, nr_timesteps_this_run, nudging,    &
+               neutral, nr_timesteps_this_run, nudging,                        &
                ocean, on_device, passive_scalar, precipitation,                &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
@@ -280,6 +281,4 @@
     CHARACTER (LEN=9) ::  time_to_string          !< 
 
-    INTEGER(iwp)      ::  netcdf_data_format_save !< 
-
 !
 !-- At the beginning of a simulation determine the time step as well as
@@ -1048,10 +1047,5 @@
 
 !
-!--    masked data output
-!--    Parallel netcdf output is not tested so far for masked data, hence 
-!--    netcdf_data_format is switched back to non-paralell output.
-       netcdf_data_format_save = netcdf_data_format
-       IF ( netcdf_data_format == 5 ) netcdf_data_format = 3
-       IF ( netcdf_data_format == 6 ) netcdf_data_format = 4
+!--    Masked data output
        DO  mid = 1, masks
           IF ( time_domask(mid) >= dt_domask(mid) )  THEN
@@ -1061,5 +1055,4 @@
           ENDIF
        ENDDO
-       netcdf_data_format = netcdf_data_format_save
 
 !
@@ -1071,13 +1064,7 @@
           CALL data_output_2d( 'yz', 1 )
           CALL data_output_3d( 1 )
-!--       Parallel netcdf output is not tested so far for masked data, hence 
-!--       netcdf_data_format is switched back to non-paralell output.
-          netcdf_data_format_save = netcdf_data_format
-          IF ( netcdf_data_format == 5 ) netcdf_data_format = 3
-          IF ( netcdf_data_format == 6 ) netcdf_data_format = 4
           DO  mid = 1, masks
              CALL data_output_mask( 1 )
           ENDDO
-          netcdf_data_format = netcdf_data_format_save
           time_do_av = MOD( time_do_av, MAX( dt_data_output_av, dt_3d ) )
        ENDIF
